
function love.load()
	val = 0

	me = love.graphics.newShader([[
		
		int pointer;			//pointer to xoffsets array
	 
		extern float xoffsets[3];		//array for X offsets
		extern int maxp;			//maximum pointer to xoffsets array
	  
		#ifdef VERTEX
			vec4 position( mat4 transform_projection, vec4 vertex_position )
			{
				float xoffset = xoffsets[pointer];
				
				pointer++;
				if (maxp < pointer) {
					pointer = 0;
				}
				
				vertex_position = vec4(vertex_position[0]+xoffset, vertex_position[1], vertex_position[2], vertex_position[3]);
				
				return transform_projection * vertex_position;
			}
		#endif
		 
		#ifdef PIXEL
			vec4 effect( vec4 color, Image texture, vec2 texture_coords, vec2 screen_coords )
			{
					//always TRUE, need to have this, otherwise maxp doesn't exist (defined but not used)
				if (maxp < 1000) {
					vec4 texcolor = Texel(texture, texture_coords);
					return texcolor * color;
				}
			}
		#endif
	
	]])
	
	poly = {100, 200, 600, 300, 300, 500}
	xoffsets = {100, -100, 20}
end

function saveScreenshot()
  local name = string.format("screenshot-%s.png", os.date("%Y-%m-%d-%H-%M-%S"))
  local shot = love.graphics.newScreenshot()
  shot:encode("png", name)
end

function love.keypressed(keyConstant, scanCode, isRepeat)
	if keyConstant == "printscreen" then
		if not isRepeat then
			saveScreenshot()
		end
	end
end

function love.draw()
	
	love.graphics.setColor(255, 255, 255)
	love.graphics.polygon('fill', poly)
	
	love.graphics.setColor(255, 0, 0)
	love.graphics.setShader(me) do
		me:send("xoffsets", xoffsets[1], xoffsets[2], xoffsets[3])
		me:send("maxp", 2)
	
		love.graphics.polygon('line', poly)
	love.graphics.setShader() end
	
	love.graphics.setColor(0, 255, 0)
	love.graphics.polygon('line', poly[1]+xoffsets[1], poly[2], poly[3]+xoffsets[2], poly[4], poly[5]+xoffsets[3], poly[6])	
end
